/********************************************************************
 *																	*
 * Software Name:  DSRT_NT											*
 * PLatform:       WIndows 2000										*
 * Version Number: 2.1												*
 * Release Date:   01/28/2001										*
 *																	*
 * Copyright:														*
 *		Monet Group,												*
 *		http://cairo.cs.uiuc.edu/									*
 *		Department of Computer Science,								*
 *		University of Illinois at Urbana Champaign.					*
 *																	*
 * Contacting Authors:												*
 *   Wanghong Yuan, Klara Nahrstedt {wyuan1,klara}@cs.uiuc.edu)		*
 *																	* 
 ********************************************************************/

// CPUApi.h: interface for the CCPUApi class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_CPUAPI_H__B902EE96_E4DE_4479_9DA0_BDFDBBE54E08__INCLUDED_)
#define AFX_CPUAPI_H__B902EE96_E4DE_4479_9DA0_BDFDBBE54E08__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "MsgQueue.h"
#include "DataStructures.h"

// each RT thread has an instance of CCPUApi
class CCPUApi  
{
private:
	DWORD		m_dwThreadId;		//thread id of the RT thread, system uniqe
	HANDLE		m_hYieldSemaAtApi;	//handle of yield semaphone in the context of CPUApi
	HANDLE		m_hContiSemaAtApi;  //wait after yield, continue only after released by server

private:
	BOOL		sendRecvMsg(CMessage& msg); 

public:
	CCPUApi();  //CPUApi and RThread are in same thread
	CCPUApi(DWORD dwPid, DWORD dwThrdId, HANDLE hThrdAtCln);
	virtual ~CCPUApi();

	// Following methods are used to send message to CPU server	
	BOOL Probe(LONG lPeriod);    //probe to determine the reservation parameters
	BOOL ProbeEnd(CCPUReserve& resv); //end probe to get the parameters

	BOOL Reserve(CCPUReserve resv); //reserve CPU with parameters from resv
	BOOL StartRTRun();  //start to run as a realtime thread
	BOOL StopRTRun();   //stop running as a realtime thread
	BOOL YieldCPU();	//yield CPU to mark the end of current iteration
	BOOL KillRThread(); //exit the RT thread

	BOOL UpdateReservation(CCPUReserve); //update the reservation
	BOOL FreeReservation();	//finish realtime run and free the reservation				
	BOOL KillServer(); //kill cpu server
};

#endif // !defined(AFX_CPUAPI_H__B902EE96_E4DE_4479_9DA0_BDFDBBE54E08__INCLUDED_)

