#include <jni.h>
#include <iostream.h>
#include "rtplayer_realtime_RTime.h"
#include "CpuApi.H"

//global var

CCPUApi *g_pCPUApi = NULL;

/*
 * Class:     RTime
 * Method:    Initialize
 * Signature: ()Z
 */
JNIEXPORT jboolean JNICALL Java_rtplayer_realtime_RTime_Initialize
  (JNIEnv *, jobject)
{
	if(!g_pCPUApi){
		g_pCPUApi = new CCPUApi();
		return TRUE;
	}
	cout<<"Call init more than once"<<endl;
	return FALSE;
}

/*
 * Class:     RTime
 * Method:    ExitRTime
 * Signature: ()Z
 */
JNIEXPORT void JNICALL Java_rtplayer_realtime_RTime_ExitRTime
  (JNIEnv *, jobject)
{
	if(g_pCPUApi){
		delete g_pCPUApi;
		g_pCPUApi = NULL;
	}
}

/*
 * Class:     RTime
 * Method:    Probe
 * Signature: (J)Z
 */
JNIEXPORT jboolean JNICALL Java_rtplayer_realtime_RTime_Probe
  (JNIEnv *, jobject, jlong period)
{
	if(g_pCPUApi){
		return g_pCPUApi->Probe(period);
	}
	return FALSE;
}

/*
 * Class:     RTime
 * Method:    ProbeEnd
 * Signature: (D)Z
 */
JNIEXPORT jdouble JNICALL Java_rtplayer_realtime_RTime_ProbeEnd
  (JNIEnv *, jobject)
{
	if(g_pCPUApi){
		CCPUReserve resv;
		if(g_pCPUApi->ProbeEnd(resv))
			return resv.m_dPercentage;
		else
			return -1;
	}
	return -1;
}

/*
 * Class:     RTime
 * Method:    Reserve
 * Signature: (JD)Z
 */
JNIEXPORT jboolean JNICALL Java_rtplayer_realtime_RTime_Reserve
  (JNIEnv *, jobject, jlong period, jdouble percentage)
{
	if(g_pCPUApi){
		CCPUReserve resv(period, percentage);
		return g_pCPUApi->Reserve(resv);
	}
	return FALSE;
}

/*
 * Class:     RTime
 * Method:    StartRTRun
 * Signature: ()Z
 */
JNIEXPORT jboolean JNICALL Java_rtplayer_realtime_RTime_StartRTRun
  (JNIEnv *, jobject)
{
	if(g_pCPUApi){
		return g_pCPUApi->StartRTRun();
	}
	return FALSE;
}

/*
 * Class:     RTime
 * Method:    StopRTRun
 * Signature: ()Z
 */
JNIEXPORT jboolean JNICALL Java_rtplayer_realtime_RTime_StopRTRun
  (JNIEnv *, jobject)
{
	if(g_pCPUApi){
		return g_pCPUApi->StopRTRun();
	}
	return FALSE;
}


/*
 * Class:     RTime
 * Method:    YieldCPU
 * Signature: ()Z
 */
JNIEXPORT jboolean JNICALL Java_rtplayer_realtime_RTime_YieldCPU
  (JNIEnv *, jobject)
{
	if(g_pCPUApi){
		return g_pCPUApi->YieldCPU();
	}
	return FALSE;
}

/*
 * Class:     RTime
 * Method:    KillRThread
 * Signature: ()Z
 */
JNIEXPORT jboolean JNICALL Java_rtplayer_realtime_RTime_KillRThread
  (JNIEnv *, jobject)
{
	if(g_pCPUApi){
		return g_pCPUApi->KillRThread();
	}
	return FALSE;
}

/*
 * Class:     RTime
 * Method:    UpdateReservation
 * Signature: (JD)Z
 */
JNIEXPORT jboolean JNICALL Java_rtplayer_realtime_RTime_UpdateReservation
  (JNIEnv *, jobject, jlong period, jdouble percentage)
{
	if(g_pCPUApi){
		CCPUReserve resv(period, percentage);
		return g_pCPUApi->UpdateReservation(resv);
	}
	return FALSE;
}

/*
 * Class:     RTime
 * Method:    FreeReservation
 * Signature: ()Z
 */
JNIEXPORT jboolean JNICALL Java_rtplayer_realtime_RTime_FreeReservation
  (JNIEnv *, jobject)
{
	if(g_pCPUApi){
		return g_pCPUApi->FreeReservation();
	}
	return FALSE;
}


/*
 * Class:     RTime
 * Method:    KillServer
 * Signature: ()Z
 */
JNIEXPORT jboolean JNICALL Java_rtplayer_realtime_RTime_KillServer
  (JNIEnv *, jobject)
{
	if(g_pCPUApi){
		return g_pCPUApi->KillServer();
	}
	return FALSE;
}
